#ifndef _CONFIG_H_
#define _CONFIG_H_

#include <stdbool.h>

#define MAX_URL_LENGTH         256
#define MAC_ADDR_LEN            32
#define MAX_IP_LEN              32
#define MAX_IPV6_LEN            40

#define FILTER_ACTIVE            1
#define FILTER_INACTIVE          0

typedef struct url_list {
	char url[1024];
	int match_cnt;
} url_list;

typedef struct profile_info {
	char name[256];
	url_list *blacklist_url;
	url_list *whitelist_url;
	unsigned int blacklist_url_cnt;
	unsigned int whitelist_url_cnt;
} profile;

typedef struct filter_info {
	bool enable;
	profile *p; // pointer to profile associated with this filter instance
	char **mac_list;
	unsigned int mac_cnt;
	int day[7];
	char start_time[8];
	unsigned int duration;
} filter;

typedef struct global_info {
	bool enable_filtering;
	bool enable_global_blacklisting;
	url_list *blacklist_url;
	unsigned int blacklist_url_cnt;
} global;

extern url_list *global_blacklisted_urls;
extern size_t global_blacklisted_urls_cnt;

extern profile *url_profile;
extern size_t profile_cnt;

extern filter *url_filter;
extern size_t filter_cnt;

extern global url_global;


extern size_t dns_server_cnt;
extern char **dns_server_ip;
// This functions reads the config from the uci file and stores in structures
int read_config(void);
#endif
